package tests;

import ProcessingUnit.ProcessingUnit.ProcessingUnitStructure;
import ProcessingUnit.ProcessingUnitServer.ProcessingUnitServerStructure;
import ResponseCache.ResponseCache.ResponseCacheState;
import references.references.*;

import static ResponseCache.ResponseCache.ResponseCache.ResponseCacheInitialize;
import static ResponseCache.ResponseCache.ResponseCache.ResponseCacheIteration;
import static arrays.arrays.arrays.NumberArrayToString;
import static arrays.arrays.arrays.StringToNumberArray;
import static references.references.references.*;
import static testing.testing.testing.AssertEquals;
import static testing.testing.testing.AssertStringEquals;

public class tests {
    public static double test(){
        NumberReference failures;

        failures = CreateNumberReference(0d);

        TestResponseCacheIteration1(failures);

        return failures.numberValue;
    }

    public static void TestResponseCacheIteration1(NumberReference failures) {
        ProcessingUnitServerStructure client, adminPort;
        ProcessingUnitStructure server;
        char [] str;
        ResponseCacheState state;
        NumberReference idleRef;

        state = new ResponseCacheState();
        idleRef = CreateNumberReference(0d);

        adminPort = new ProcessingUnitServerStructure();
        adminPort.requests = new NumberArrayReference[1];
        adminPort.requests[0] = CreateNumberArrayReferenceLengthValue(0d, 0d);
        adminPort.requestCount = 0d;
        adminPort.responseCount = 0d;
        adminPort.responses = new NumberArrayReference[1];
        adminPort.responses[0] = new NumberArrayReference();
        adminPort.check = new double [2];
        adminPort.check[0] = 1d;
        adminPort.check[1] = 20d;

        client = new ProcessingUnitServerStructure();
        client.requests = new NumberArrayReference[2];
        client.requests[0] = new NumberArrayReference();
        client.requests[0].numberArray = StringToNumberArray("request 1".toCharArray());
        client.requests[1] = new NumberArrayReference();
        client.requests[1].numberArray = StringToNumberArray("request 1".toCharArray());
        client.requestCount = 0d;
        client.responseCount = 0d;
        client.responses = new NumberArrayReference[2];
        client.check = new double [2];
        client.check[0] = 0d;
        client.check[1] = 0d;

        server = new ProcessingUnitStructure();
        server.requests = new NumberArrayReference[2];
        server.requests[0] = new NumberArrayReference();
        server.requests[1] = new NumberArrayReference();
        server.requestCount = 0d;
        server.responseCount = 0d;
        server.responses = new NumberArrayReference[2];
        server.responses[0] = new NumberArrayReference();
        server.responses[0].numberArray = StringToNumberArray("response 1".toCharArray());
        server.responses[1] = new NumberArrayReference();
        server.responses[1].numberArray = StringToNumberArray("response 2".toCharArray());
        server.check = new double [1];
        server.check[0] = 0d;

        ResponseCacheInitialize(client, adminPort, server, 10d, 200d, state);

        ResponseCacheIteration(client, adminPort, server, state, idleRef);
        ResponseCacheIteration(client, adminPort, server, state, idleRef);

        AssertEquals(client.responseCount, 2d, failures);

        AssertEquals(server.requestCount, 1d, failures);

        str = NumberArrayToString(server.requests[0].numberArray);
        AssertStringEquals(str, "request 1".toCharArray(), failures);

        str = NumberArrayToString(client.responses[0].numberArray);
        AssertStringEquals(str, "response 1".toCharArray(), failures);

        str = NumberArrayToString(client.responses[1].numberArray);
        AssertStringEquals(str, "response 1".toCharArray(), failures);

        str = NumberArrayToString(adminPort.responses[0].numberArray);
        AssertStringEquals(str, "{\"idles\":0,\"Client Reqs\":2,\"Cached Reqs\":1,\"Duplicate Hash Req\":0,\"Over Cache Max Req\":0}".toCharArray(), failures);
    }
}







